PF-build.sh 62 KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465666768697071727374757677787980818283848586878889909192939495969798991001011021031041051061071081091101111121131141151161171181191201211221231241251261271281291301311321331341351361371381391401411421431441451461471481491501511521531541551561571581591601611621631641651661671681691701711721731741751761771781791801811821831841851861871881891901911921931941951961971981992002012022032042052062072082092102112122132142152162172182192202212222232242252262272282292302312322332342352362372382392402412422432442452462472482492502512522532542552562572582592602612622632642652662672682692702712722732742752762772782792802812822832842852862872882892902912922932942952962972982993003013023033043053063073083093103113123133143153163173183193203213223233243253263273283293303313323333343353363373383393403413423433443453463473483493503513523533543553563573583593603613623633643653663673683693703713723733743753763773783793803813823833843853863873883893903913923933943953963973983994004014024034044054064074084094104114124134144154164174184194204214224234244254264274284294304314324334344354364374384394404414424434444454464474484494504514524534544554564574584594604614624634644654664674684694704714724734744754764774784794804814824834844854864874884894904914924934944954964974984995005015025035045055065075085095105115125135145155165175185195205215225235245255265275285295305315325335345355365375385395405415425435445455465475485495505515525535545555565575585595605615625635645655665675685695705715725735745755765775785795805815825835845855865875885895905915925935945955965975985996006016026036046056066076086096106116126136146156166176186196206216226236246256266276286296306316326336346356366376386396406416426436446456466476486496506516526536546556566576586596606616626636646656666676686696706716726736746756766776786796806816826836846856866876886896906916926936946956966976986997007017027037047057067077087097107117127137147157167177187197207217227237247257267277287297307317327337347357367377387397407417427437447457467477487497507517527537547557567577587597607617627637647657667677687697707717727737747757767777787797807817827837847857867877887897907917927937947957967977987998008018028038048058068078088098108118128138148158168178188198208218228238248258268278288298308318328338348358368378388398408418428438448458468478488498508518528538548558568578588598608618628638648658668678688698708718728738748758768778788798808818828838848858868878888898908918928938948958968978988999009019029039049059069079089099109119129139149159169179189199209219229239249259269279289299309319329339349359369379389399409419429439449459469479489499509519529539549559569579589599609619629639649659669679689699709719729739749759769779789799809819829839849859869879889899909919929939949959969979989991000100110021003100410051006100710081009101010111012101310141015101610171018101910201021102210231024102510261027102810291030103110321033103410351036103710381039104010411042104310441045104610471048104910501051105210531054105510561057105810591060106110621063106410651066106710681069107010711072107310741075107610771078107910801081108210831084108510861087108810891090109110921093109410951096109710981099110011011102110311041105110611071108110911101111111211131114111511161117111811191120112111221123112411251126112711281129113011311132113311341135113611371138113911401141114211431144114511461147114811491150115111521153115411551156115711581159116011611162116311641165116611671168116911701171117211731174117511761177117811791180118111821183118411851186118711881189119011911192119311941195119611971198119912001201120212031204120512061207120812091210121112121213121412151216121712181219122012211222122312241225122612271228122912301231123212331234123512361237
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 2.0.0-Build_56
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. # 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
  139. # 12 Feb 2021, 3d-gussner, Add MK404-build.sh
  140. # 13 Feb 2021, 3d-gussner, Indentations
  141. # 13 Feb 2021, 3d-gussner, MK404 improvements like "flash" MK3, MK3S languages files to MK404 xflash.
  142. # 27 Feb 2021, 3d-gussner, Add './lang-community.sh' and update exits
  143. # 03 May 2021, 3d-gussner, Update exit numbers
  144. # 01-14 prepare build env
  145. # 21-32 prepare compiling
  146. # 41-47 compiling
  147. # 51-54 cleanup
  148. # 61-62 MK404
  149. # 03 May 2021, 3d-gussner, Update documentation and change version to v1.2.0
  150. # 03 May 2021, 3d-gussner, Add SIM atmega404
  151. # 17 Jun 2021, 3d-gussner, Update PF-build.sh to work after DRracer Remove FW version parsing PR
  152. # 17 Jun 2021, 3d-gussner, Save ELF files for FW3.10.1 debugging PRs
  153. # 17 Jun 2021, 3d-gussner, Add verbose_IDE to output more information during build
  154. # 17 Jun 2021, 3d-gussner, Change version to v2.0.0
  155. # 18 Jun 2021, 3d-gussner, Use atmega404 if extanded RAM or FLASH size are chosen
  156. # 18 Jun 2021, 3d-gussner, Remove MK404 copy of lang file as it has been fixed in MK404
  157. #### Start check if OSTYPE is supported
  158. OS_FOUND=$( command -v uname)
  159. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  160. linux*)
  161. TARGET_OS="linux"
  162. ;;
  163. msys*|cygwin*|mingw*)
  164. # or possible 'bash on windows'
  165. TARGET_OS='windows'
  166. ;;
  167. nt|win*)
  168. TARGET_OS='windows'
  169. ;;
  170. *)
  171. TARGET_OS='unknown'
  172. ;;
  173. esac
  174. # Windows
  175. if [ $TARGET_OS == "windows" ]; then
  176. if [ $(uname -m) == "x86_64" ]; then
  177. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  178. Processor="64"
  179. elif [ $(uname -m) == "i386" ]; then
  180. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  181. Processor="32"
  182. else
  183. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  184. echo "Please refer to the notes of build.sh$(tput sgr0)"
  185. exit 1
  186. fi
  187. # Linux
  188. elif [ $TARGET_OS == "linux" ]; then
  189. if [ $(uname -m) == "x86_64" ]; then
  190. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  191. Processor="64"
  192. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  193. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  194. Processor="32"
  195. else
  196. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  197. echo "Please refer to the notes of build.sh$(tput sgr0)"
  198. exit 1
  199. fi
  200. else
  201. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  202. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  203. echo "Read the notes of build.sh$(tput sgr0)"
  204. exit 1
  205. fi
  206. sleep 2
  207. #### End check if OSTYPE is supported
  208. #### Prepare bash environment and check if wget, zip and other needed things are available
  209. # Check wget
  210. if ! type wget > /dev/null; then
  211. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  212. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  213. exit 2
  214. fi
  215. # Check for zip
  216. if ! type zip > /dev/null; then
  217. if [ $TARGET_OS == "windows" ]; then
  218. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  219. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  220. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  221. echo "Run git Bash under Administrator privilege and"
  222. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  223. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  224. exit 3
  225. elif [ $TARGET_OS == "linux" ]; then
  226. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  227. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  228. #sudo apt-get update && apt-get install zip
  229. exit 3
  230. fi
  231. fi
  232. # Check python ... needed during language build
  233. if ! type python > /dev/null; then
  234. if [ $TARGET_OS == "windows" ]; then
  235. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  236. exit 4
  237. elif [ $TARGET_OS == "linux" ]; then
  238. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  239. echo "As Python 2.x will not be maintained from 2020 please,"
  240. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  241. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  242. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  243. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  244. exit 4
  245. fi
  246. fi
  247. # Check gawk ... needed during language build
  248. if ! type gawk > /dev/null; then
  249. if [ $TARGET_OS == "linux" ]; then
  250. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  251. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  252. #sudo apt-get update && apt-get install gawk
  253. exit 5
  254. fi
  255. fi
  256. #### End prepare bash / Linux environment
  257. # Check for options/flags
  258. while getopts b:c:d:f:g:h:i:j:l:m:n:o:p:v:x:?h flag
  259. do
  260. case "${flag}" in
  261. b) build_flag=${OPTARG};;
  262. c) clean_flag=${OPTARG};;
  263. d) devel_flag=${OPTARG};;
  264. f) board_flash_flag=${OPTARG};;
  265. g) graphics_flag=${OPTARG};;
  266. h) help_flag=1;;
  267. i) IDE_flag=${OPTARG};;
  268. j) verbose_IDE_flag=${OPTARG};;
  269. l) language_flag=${OPTARG};;
  270. m) mk404_flag=${OPTARG};;
  271. n) new_build_flag=${OPTARG};;
  272. o) output_flag=${OPTARG};;
  273. p) prusa_flag=${OPTARG};;
  274. v) variant_flag=${OPTARG};;
  275. x) board_mem_flag=${OPTARG};;
  276. ?) help_flag=1;;
  277. esac
  278. done
  279. #
  280. # '?' 'h' argument usage and help
  281. if [ "$help_flag" == "1" ] ; then
  282. echo "***************************************"
  283. echo "* PF-build.sh Version: 2.0.0-Build_56 *"
  284. echo "***************************************"
  285. echo "Arguments:"
  286. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  287. echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build'$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  288. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  289. echo "$(tput setaf 2)-f$(tput sgr0) Board flash size '$(tput setaf 2)256$(tput sgr0)','$(tput setaf 2)384$(tput sgr0)','$(tput setaf 2)512$(tput sgr0)','$(tput setaf 2)1024$(tput sgr0)''$(tput setaf 2)32M$(tput sgr0)'"
  290. echo "$(tput setaf 2)-g$(tput sgr0) Start MK404 grafics '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' lite '$(tput setaf 2)2$(tput sgr0)' fancy"
  291. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  292. echo "$(tput setaf 2)-i$(tput sgr0) Arduino IDE version '$(tput setaf 2)1.8.5$(tput sgr0)', '$(tput setaf 2)1.8.13$(tput sgr0)'"
  293. echo "$(tput setaf 2)-j$(tput sgr0) Arduino IDE verbose output '$(tput setaf 2)0$(tput sgr0)', '$(tput setaf 2)1$(tput sgr0) active'"
  294. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  295. echo "$(tput setaf 2)-m$(tput sgr0) Start MK404 sim '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes '$(tput setaf 2)2$(tput sgr0)' with MMU2"
  296. echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  297. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  298. echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  299. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  300. echo "$(tput setaf 2)-x$(tput sgr0) Board memory size '$(tput setaf 2)8$(tput sgr0)' or '$(tput setaf 2)64$(tput sgr0)' Kb."
  301. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  302. echo
  303. echo "Brief USAGE:"
  304. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-v] [-l] [-d] [-b] [-o] [-c] [-p] [-n]"
  305. echo
  306. echo "Example:"
  307. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  308. echo " Will build all variants as multi language and final GOLD version"
  309. echo
  310. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
  311. echo " Will build MK3S multi language final GOLD firmware "
  312. echo " with current commit count number and output extra information,"
  313. echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
  314. echo
  315. exit 6
  316. fi
  317. #Check if verbose_IDE is selected with argument '-j'
  318. if [ ! -z "$verbose_IDE_flag" ]; then
  319. if [ $verbose_IDE_flag == "1" ]; then
  320. verbose_IDE="1"
  321. elif [ $verbose_IDE_flag == "0" ]; then
  322. verbose_IDE="0"
  323. else
  324. echo "Only '0' and '1' are valid verbose_IDE values."
  325. exit
  326. fi
  327. else
  328. verbose_IDE="0"
  329. fi
  330. #Check if Build is selected with argument '-f'
  331. if [ ! -z "$board_flash_flag" ] ; then
  332. if [ "$board_flash_flag" == "256" ] ; then
  333. BOARD_FLASH="0x3FFFF"
  334. BOARD_maximum_size="253952"
  335. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  336. elif [ "$board_flash_flag" == "384" ] ; then
  337. BOARD_FLASH="0x5FFFF"
  338. BOARD_maximum_size="385024"
  339. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  340. elif [ "$board_flash_flag" == "512" ] ; then
  341. BOARD_FLASH="0x7FFFF"
  342. BOARD_maximum_size="516096"
  343. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  344. elif [ "$board_flash_flag" == "1024" ] ; then
  345. BOARD_FLASH="0xFFFFF"
  346. BOARD_maximum_size="1040384"
  347. echo "Board flash size : $board_flash_flag Kb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  348. elif [[ "$board_flash_flag" == "32M" || "$board_flash_flag" == "32768" ]] ; then
  349. BOARD_FLASH="0x1FFFFFF"
  350. BOARD_maximum_size="33546240"
  351. echo "Board flash size : 32 Mb, $BOARD_maximum_size bytes, $BOARD_FLASH (hex)"
  352. else
  353. echo "Unsupported board flash size chosen. Only '256', '384', '512', '1024' and '32M' are allowed."
  354. exit 7
  355. fi
  356. fi
  357. #Check if Build is selected with argument '-x'
  358. if [ ! -z "$board_mem_flag" ] ; then
  359. if [ "$board_mem_flag" == "8" ] ; then
  360. BOARD_MEM="0x21FF"
  361. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  362. elif [ "$board_mem_flag" == "64" ] ; then
  363. BOARD_MEM="0xFFFF"
  364. echo "Board mem size : $board_mem_flag Kb, $BOARD_MEM (hex)"
  365. else
  366. echo "Unsupported board mem size chosen. Only '8', '64' are allowed."
  367. exit 8
  368. fi
  369. fi
  370. #Check if Arduino IDE version is correct
  371. if [ ! -z "$IDE_flag" ]; then
  372. if [[ "$IDE_flag" == "1.8.5" || "$IDE_flag" == "1.8.13" ]]; then
  373. ARDUINO_ENV="${IDE_flag}"
  374. else
  375. ARDUINO_ENV="1.8.5"
  376. fi
  377. else
  378. ARDUINO_ENV="1.8.5"
  379. fi
  380. #### Set build environment
  381. BUILD_ENV="1.0.6"
  382. BOARD="prusa_einsy_rambo"
  383. BOARD_PACKAGE_NAME="PrusaResearch"
  384. BOARD_VERSION="1.0.3"
  385. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  386. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  387. BOARD_FILENAME="prusa3dboards"
  388. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  389. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  390. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  391. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  392. LIB="PrusaLibrary"
  393. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  394. # List few useful data
  395. echo
  396. echo "Script path :" $SCRIPT_PATH
  397. echo "OS :" $OS
  398. echo "OS type :" $TARGET_OS
  399. echo ""
  400. echo "Arduino IDE :" $ARDUINO_ENV
  401. echo "Build env :" $BUILD_ENV
  402. echo "Board :" $BOARD
  403. if [ ! -z "$BOARD_FLASH" ] ; then
  404. echo "Board flash :" $BOARD_FLASH
  405. fi
  406. if [ ! -z "$BOARD_MEM" ] ; then
  407. echo "Board mem :" $BOARD_MEM
  408. fi
  409. echo "Package name:" $BOARD_PACKAGE_NAME
  410. echo "Board v. :" $BOARD_VERSION
  411. echo "Specific Lib:" $LIB
  412. echo ""
  413. #### Start prepare building environment
  414. #Check if build exists and creates it if not
  415. if [ ! -d "../PF-build-dl" ]; then
  416. mkdir ../PF-build-dl || exit 9
  417. fi
  418. cd ../PF-build-dl || exit 10
  419. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  420. # Check if PF-build-env-<version> exists and downloads + creates it if not
  421. # The build environment is based on the supported Arduino IDE portable version with some changes
  422. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  423. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  424. mkdir ../PF-build-env-$BUILD_ENV
  425. sleep 5
  426. fi
  427. # Download and extract supported Arduino IDE depending on OS
  428. # Windows
  429. if [ $TARGET_OS == "windows" ]; then
  430. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  431. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  432. sleep 2
  433. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 8
  434. echo "$(tput sgr 0)"
  435. fi
  436. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  437. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  438. sleep 2
  439. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 9
  440. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  441. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  442. echo "$(tput sgr0)"
  443. fi
  444. fi
  445. # Linux
  446. if [ $TARGET_OS == "linux" ]; then
  447. # 32 or 64 bit version
  448. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  449. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  450. sleep 2
  451. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  452. echo "$(tput sgr 0)"
  453. fi
  454. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  455. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  456. sleep 2
  457. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 9
  458. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  459. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  460. echo "$(tput sgr0)"
  461. fi
  462. fi
  463. # Make Arduino IDE portable
  464. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  465. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  466. fi
  467. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  468. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  469. fi
  470. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  471. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  472. fi
  473. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  474. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  475. fi
  476. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  477. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  478. fi
  479. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  480. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  481. fi
  482. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  483. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  484. fi
  485. # Change Arduino IDE preferences
  486. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  487. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  488. sleep 2
  489. echo "update.check"
  490. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  491. echo "board"
  492. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  493. echo "editor.linenumbers"
  494. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  495. echo "boardsmanager.additional.urls"
  496. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  497. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  498. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  499. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  500. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  501. echo "$(tput sgr0)"
  502. fi
  503. # Download and extract Prusa Firmware related parts
  504. # Download and extract PrusaResearchRambo board
  505. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  506. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  507. sleep 2
  508. wget $BOARD_FILE_URL || exit 10
  509. fi
  510. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  511. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  512. sleep 2
  513. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 11
  514. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  515. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  516. fi
  517. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  518. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  519. fi
  520. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  521. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  522. fi
  523. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  524. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  525. fi
  526. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  527. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  528. echo "$(tput sgr 0)"
  529. fi
  530. # Download and extract Prusa Firmware specific library files
  531. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  532. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  533. sleep 2
  534. wget $PF_BUILD_FILE_URL || exit 12
  535. echo "$(tput sgr 0)"
  536. fi
  537. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  538. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  539. sleep 2
  540. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 13
  541. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  542. echo "$(tput sgr0)"
  543. fi
  544. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  545. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  546. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  547. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  548. sleep 2
  549. fi
  550. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  551. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  552. sleep 2
  553. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  554. sleep 2
  555. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  556. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  557. echo "$(tput sgr0)"
  558. fi
  559. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  560. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  561. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  562. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  563. sleep 2
  564. echo "$(tput sgr0)"
  565. exit 14
  566. fi
  567. #### End prepare building
  568. #### Start
  569. cd $SCRIPT_PATH
  570. # Check if git is available
  571. if type git > /dev/null; then
  572. git_available="1"
  573. fi
  574. #
  575. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  576. if [ -z "$variant_flag" ] ; then
  577. # Select which variant of the Prusa Firmware will be compiled, like
  578. PS3="Select a variant: "
  579. while IFS= read -r -d $'\0' f; do
  580. options[i++]="$f"
  581. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  582. select opt in "${options[@]}" "All" "Quit"; do
  583. case $opt in
  584. *.h)
  585. VARIANT=$(basename "$opt" ".h")
  586. VARIANTS[i++]="$opt"
  587. break
  588. ;;
  589. "All")
  590. VARIANT="All"
  591. VARIANTS=${options[*]}
  592. break
  593. ;;
  594. "Quit")
  595. echo "You chose to stop"
  596. exit 22
  597. ;;
  598. *)
  599. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  600. ;;
  601. esac
  602. done
  603. else
  604. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  605. VARIANTS=$variant_flag
  606. elif [ "$variant_flag" == "All" ] ; then
  607. while IFS= read -r -d $'\0' f; do
  608. options[i++]="$f"
  609. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  610. VARIANT="All"
  611. VARIANTS=${options[*]}
  612. else
  613. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  614. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  615. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  616. echo "$(tput sgr0)"
  617. exit 23
  618. fi
  619. fi
  620. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  621. #Check default language mode
  622. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  623. if [ -z "$language_flag" ] ; then
  624. PS3="Select a language: "
  625. echo
  626. echo "Which lang-build do you want?"
  627. select yn in "Multi languages" "English only"; do
  628. case $yn in
  629. "Multi languages")
  630. LANGUAGES="ALL"
  631. break
  632. ;;
  633. "English only")
  634. LANGUAGES="EN_ONLY"
  635. break
  636. ;;
  637. *)
  638. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  639. ;;
  640. esac
  641. done
  642. else
  643. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  644. LANGUAGES=$language_flag
  645. else
  646. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  647. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  648. exit 24
  649. fi
  650. fi
  651. #Check if DEV_STATUS is selected via argument '-d'
  652. if [ ! -z "$devel_flag" ] ; then
  653. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  654. DEV_STATUS_SELECTED=$devel_flag
  655. elif [[ "$devel_flag" == "atmega404" || "$devel_flag" == "atmega404_no_bootloader" ]] ; then
  656. MK404_DEBUG=$devel_flag
  657. else
  658. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  659. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  660. exit 25
  661. fi
  662. fi
  663. #Check if Build is selected via argument '-b'
  664. if [ ! -z "$build_flag" ] ; then
  665. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  666. echo "Build changed to $build_flag"
  667. BUILD=$(git rev-list --count HEAD)
  668. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  669. BUILD=$build_flag
  670. else
  671. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  672. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  673. exit 26
  674. fi
  675. echo "New Build number is: $BUILD"
  676. fi
  677. # check if script has been started with arguments
  678. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  679. OUTPUT=1
  680. else
  681. OUTPUT=0
  682. fi
  683. #echo "Output is:" $OUTPUT
  684. #Check git branch has changed
  685. if [ ! -z "git_available" ]; then
  686. BRANCH=""
  687. CLEAN_PF_FW_BUILD=0
  688. else
  689. BRANCH=$(git branch --show-current)
  690. echo "Current branch is:" $BRANCH
  691. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  692. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  693. echo "created PF-build.branch file"
  694. else
  695. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  696. echo "Previous branch was:" $PRE_BRANCH
  697. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  698. CLEAN_PF_FW_BUILD=1
  699. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  700. fi
  701. fi
  702. fi
  703. #Set BUILD_ENV_PATH
  704. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 27
  705. BUILD_ENV_PATH="$( pwd -P )"
  706. cd ../..
  707. #Checkif BUILD_PATH exists and if not creates it
  708. if [ ! -d "Prusa-Firmware-build" ]; then
  709. mkdir Prusa-Firmware-build || exit 28
  710. fi
  711. #Set the BUILD_PATH for Arduino IDE
  712. cd Prusa-Firmware-build || exit 29
  713. BUILD_PATH="$( pwd -P )"
  714. #Check git branch has changed
  715. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  716. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  717. rm -r *
  718. else
  719. echo "Nothing to clean up"
  720. fi
  721. for v in ${VARIANTS[*]}
  722. do
  723. VARIANT=$(basename "$v" ".h")
  724. MK404_PRINTER=$(grep --max-count=1 "\bPRINTER_TYPE\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3 | cut -d '_' -f2)
  725. # Find firmware version in Configuration.h file and use it to generate the hex filename
  726. FW_MAJOR=$(grep --max-count=1 "\bFW_MAJOR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  727. FW_MINOR=$(grep --max-count=1 "\bFW_MINOR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  728. FW_REVISION=$(grep --max-count=1 "\bFW_REVISION\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  729. FW="$FW_MAJOR$FW_MINOR$FW_REVISION"
  730. #FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  731. if [ -z "$BUILD" ] ; then
  732. # Find build version in Configuration.h file and use it to generate the hex filename
  733. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  734. else
  735. # Find and replace build version in Configuration.h file
  736. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  737. echo "Original build number: $BUILD_ORG"
  738. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  739. fi
  740. # Check if the motherboard is an EINSY and if so only one hex file will generated
  741. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  742. # Check development status
  743. FW_FLAV=$(grep --max-count=1 "//#define FW_FLAVOR\b" $SCRIPT_PATH/Firmware/Configuration.h|cut -d ' ' -f1)
  744. if [[ "$FW_FLAV" != "//#define" ]] ; then
  745. FW_FLAVOR=$(grep --max-count=1 "\bFW_FLAVOR\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  746. FW_FLAVERSION=$(grep --max-count=1 "\bFW_FLAVERSION\b" $SCRIPT_PATH/Firmware/Configuration.h| sed -e's/ */ /g'|cut -d ' ' -f3)
  747. if [[ "$FW_FLAVOR" != "//#define FW_FLAVOR" ]] ; then
  748. FW="$FW-$FW_FLAVOR"
  749. DEV_CHECK="$FW_FLAVOR"
  750. if [ ! -z "$FW_FLAVERSION" ] ; then
  751. FW="$FW$FW_FLAVERSION"
  752. fi
  753. fi
  754. fi
  755. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  756. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  757. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  758. DEV_STATUS="RC"
  759. elif [[ "$DEV_CHECK" == *"ALPHA"* ]]; then
  760. DEV_STATUS="ALPHA"
  761. elif [[ "$DEV_CHECK" == *"BETA"* ]]; then
  762. DEV_STATUS="BETA"
  763. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  764. DEV_STATUS="DEVEL"
  765. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  766. DEV_STATUS="DEBUG"
  767. else
  768. DEV_STATUS="UNKNOWN"
  769. echo
  770. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  771. PS3="Select YES only if source code is tested and trusted: "
  772. select yn in "Yes" "No"; do
  773. case $yn in
  774. Yes)
  775. DEV_STATUS="GOLD"
  776. DEV_STATUS_SELECTED="GOLD"
  777. break
  778. ;;
  779. No)
  780. DEV_STATUS="UNKNOWN"
  781. DEV_STATUS_SELECTED="UNKNOWN"
  782. break
  783. ;;
  784. *)
  785. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  786. ;;
  787. esac
  788. done
  789. fi
  790. else
  791. DEV_STATUS=$DEV_STATUS_SELECTED
  792. fi
  793. #Prepare hex files folders
  794. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  795. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  796. fi
  797. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  798. if [ "$BOARD" != "prusa_einsy_rambo" ]; then
  799. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD" ]; then
  800. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$BOARD || exit 28
  801. fi
  802. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$BOARD"
  803. fi
  804. #Check if exactly the same hexfile already exists
  805. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  806. echo ""
  807. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  808. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  809. if [ $OUTPUT == "1" ] ; then
  810. read -t 10 -p "Press Enter to continue..."
  811. fi
  812. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  813. echo ""
  814. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  815. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  816. if [ $OUTPUT == "1" ] ; then
  817. read -t 10 -p "Press Enter to continue..."
  818. fi
  819. fi
  820. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  821. echo ""
  822. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  823. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  824. if [ $OUTPUT == "1" ] ; then
  825. read -t 10 -p "Press Enter to continue..."
  826. fi
  827. fi
  828. #List some useful data
  829. echo "$(tput setaf 2)$(tput setab 7) "
  830. echo "Printer :" $MK404_PRINTER
  831. echo "Variant :" $VARIANT
  832. echo "Firmware :" $FW
  833. echo "Build # :" $BUILD
  834. echo "Dev Check :" $DEV_CHECK
  835. echo "DEV Status :" $DEV_STATUS
  836. echo "Motherboard:" $MOTHERBOARD
  837. echo "Board flash:" $BOARD_FLASH
  838. echo "Board mem :" $BOARD_MEM
  839. echo "Languages :" $LANGUAGES
  840. echo "Hex-file Folder:" $OUTPUT_FOLDER
  841. echo "$(tput sgr0)"
  842. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  843. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  844. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  845. else
  846. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  847. if [ $OUTPUT == "1" ] ; then
  848. read -t 10 -p "Press Enter to continue..."
  849. fi
  850. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  851. fi
  852. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  853. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  854. # set FW_REPOSITORY
  855. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  856. #Prepare English only or multi-language version to be build
  857. if [ $LANGUAGES == "EN_ONLY" ]; then
  858. echo " "
  859. echo "English only language firmware will be built"
  860. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  861. echo " "
  862. else
  863. echo " "
  864. echo "Multi-language firmware will be built"
  865. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  866. echo " "
  867. fi
  868. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  869. #if [ $TARGET_OS == "windows" ]; then
  870. #RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  871. #fi
  872. #New fresh PF-Firmware-build
  873. if [ "$new_build_flag" == "1" ]; then
  874. rm -r -f $BUILD_PATH/* || exit 54
  875. fi
  876. # Prepare Board mem and flash modifications
  877. ## Check board mem size
  878. CURRENT_BOARD_MEM=$(grep "#define RAMEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  879. if [ $CURRENT_BOARD_MEM != "0x21FF" ] ; then
  880. echo "Board mem has been already modified or not reset"
  881. echo "Current:" $CURRENT_BOARD_MEM
  882. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  883. select yn in "Yes" "No"; do
  884. case $yn in
  885. Yes)
  886. echo "Resetting board mem size"
  887. sed -i -- "s/^#define RAMEND .*$/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  888. break
  889. ;;
  890. *)
  891. echo "Continuing with modified mem size"
  892. break
  893. ;;
  894. esac
  895. done
  896. fi
  897. ## Modify board mem size
  898. if [[ ! -z $BOARD_MEM && "$BOARD_MEM" != "0x21FF" ]] ; then
  899. echo "$(tput setaf 3)Modifying board memory size (hex):$(tput sgr 0)"
  900. echo "Old:" $CURRENT_BOARD_MEM
  901. echo "New:" $BOARD_MEM
  902. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  903. echo ""
  904. sed -i -- "s/^#define RAMEND 0x21FF/#define RAMEND ${BOARD_MEM}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  905. fi
  906. ## Check board flash size
  907. CURRENT_BOARD_FLASH=$(grep "#define FLASHEND" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h | sed -e's/.* //g'|cut -d ' ' -f3|tr -d $'\n')
  908. CURRENT_BOARD_maximum_size=$(grep "prusa_einsy_rambo.upload.maximum_size" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt |cut -d '=' -f2|tr -d $'\n')
  909. if [[ $CURRENT_BOARD_FLASH != "0x3FFFF" || $CURRENT_BOARD_maximum_size != "253952" ]] ; then
  910. echo "Board flash has been already modified or not reset"
  911. echo "Current flash size:" $CURRENT_BOARD_FLASH
  912. echo "Current max. size:" $CURRENT_BOARD_maximum_size
  913. PS3="Select $(tput setaf 2)Yes$(tput sgr 0) if you want to reset it."
  914. select yn in "Yes" "No"; do
  915. case $yn in
  916. Yes)
  917. echo "$(tput setaf 1)Resetting board flash size$(tput sgr 0)"
  918. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  919. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  920. break
  921. ;;
  922. *)
  923. echo "$(tput setaf 3)Continuing with modified flash size$(tput sgr 0)"
  924. break
  925. ;;
  926. esac
  927. done
  928. fi
  929. ## Modify boad flash size
  930. if [[ ! -z $BOARD_FLASH && "$BOARD_FLASH" != "0x3FFFF" ]] ; then
  931. echo "Modifying board flash size (hex):"
  932. echo "Old flash size:" $CURRENT_BOARD_FLASH
  933. echo "New flash size:" $BOARD_FLASH
  934. echo "Old max. size:" $CURRENT_BOARD_maximum_size
  935. echo "New max. size:" $BOARD_maximum_size
  936. read -t 5 -p "To cancel press $(tput setaf 1)CRTL+C$(tput sgr 0)"
  937. sed -i -- "s/^#define FLASHEND .*/#define FLASHEND ${BOARD_FLASH}/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  938. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=${BOARD_maximum_size}/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  939. fi
  940. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  941. # if [ $TARGET_OS == "windows" ]; then
  942. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  943. # fi
  944. #### End of Prepare building
  945. #### Start building
  946. export ARDUINO=$BUILD_ENV_PATH
  947. #echo $BUILD_ENV_PATH
  948. #export BUILDER=$ARDUINO/arduino-builder
  949. echo
  950. #read -t 5 -p "Press Enter..."
  951. echo
  952. echo "Start to build Prusa Firmware ..."
  953. echo "Using variant $VARIANT$(tput setaf 3)"
  954. if [ $OUTPUT == "1" ] ; then
  955. sleep 2
  956. fi
  957. if [ $verbose_IDE == "1" ]; then
  958. $BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 41
  959. fi
  960. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all -verbose=$verbose_IDE $SCRIPT_PATH/Firmware/Firmware.ino || exit 42
  961. echo "$(tput sgr 0)"
  962. if [ $LANGUAGES == "ALL" ]; then
  963. echo "$(tput setaf 2)"
  964. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  965. echo "$(tput sgr 0)"
  966. if [ $OUTPUT == "1" ] ; then
  967. sleep 2
  968. fi
  969. cd $SCRIPT_PATH/lang
  970. echo "$(tput setaf 3)"
  971. ./config.sh || exit 43
  972. echo "$(tput sgr 0)"
  973. # Check if previous languages and firmware build exist and if so clean them up
  974. if [ -f "lang_en.tmp" ]; then
  975. echo ""
  976. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  977. if [ $OUTPUT == "1" ] ; then
  978. read -t 10 -p "Press Enter to continue..."
  979. fi
  980. echo "$(tput setaf 3)"
  981. ./lang-clean.sh
  982. echo "$(tput sgr 0)"
  983. fi
  984. if [ -f "progmem.out" ]; then
  985. echo ""
  986. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  987. if [ $OUTPUT == "1" ] ; then
  988. read -t 10 -p "Press Enter to continue..."
  989. fi
  990. echo "$(tput setaf 3)"
  991. ./fw-clean.sh
  992. echo "$(tput sgr 0)"
  993. fi
  994. # build languages
  995. echo "$(tput setaf 3)"
  996. ./lang-build.sh || exit 44
  997. # build community languages
  998. ./lang-community.sh || exit 45
  999. # Combine compiled firmware with languages
  1000. ./fw-build.sh || exit 46
  1001. cp not_tran.txt not_tran_$VARIANT.txt
  1002. cp not_used.txt not_used_$VARIANT.txt
  1003. echo "$(tput sgr 0)"
  1004. # Check if the motherboard is an EINSY and if so only one hex file will generated
  1005. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  1006. # If the motherboard is an EINSY just copy one hexfile
  1007. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  1008. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  1009. # End of "lang.bin" for MK3 and MK3S copy
  1010. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1011. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.elf
  1012. else
  1013. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  1014. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  1015. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  1016. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  1017. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  1018. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  1019. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  1020. cp -f firmware_nl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-nl.hex
  1021. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.elf
  1022. if [ $TARGET_OS == "windows" ]; then
  1023. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1024. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1025. elif [ $TARGET_OS == "linux" ]; then
  1026. # Make a copy for MK404 sim of MK2, MK2.5, MK2.5S firmware
  1027. if [ ! -z "$mk404_flag" ]; then
  1028. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1029. fi
  1030. # End of MK2, MK2.5, MK2.5S firmware copy
  1031. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  1032. fi
  1033. fi
  1034. # Cleanup after build
  1035. if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
  1036. echo "$(tput setaf 3)"
  1037. ./fw-clean.sh || exit 51
  1038. ./lang-clean.sh || exit 52
  1039. echo "$(tput sgr 0)"
  1040. fi
  1041. else
  1042. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  1043. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 47
  1044. echo "$(tput setaf 2)Copying English only elf file to PF-build-hex folder$(tput sgr 0)"
  1045. cp -f $BUILD_PATH/Firmware.ino.elf $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.elf || exit 47
  1046. fi
  1047. # Cleanup Firmware
  1048. if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
  1049. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 53
  1050. fi
  1051. # Delete dupblicates
  1052. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  1053. then
  1054. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  1055. fi
  1056. # MK2 not supported in this branch
  1057. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  1058. then
  1059. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  1060. fi
  1061. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  1062. then
  1063. rm $SCRIPT_PATH/lang/not_tran.txt
  1064. fi
  1065. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  1066. then
  1067. rm $SCRIPT_PATH/lang/not_used.txt
  1068. fi
  1069. #New fresh PF-Firmware-build
  1070. if [ "$new_build_flag" == "1" ]; then
  1071. rm -r -f $BUILD_PATH/* || exit 54
  1072. fi
  1073. # Restore files to previous state
  1074. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  1075. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  1076. if [ ! -z "$BUILD_ORG" ] ; then
  1077. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  1078. fi
  1079. echo $MULTI_LANGUAGE_CHECK
  1080. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  1081. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1082. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  1083. if [ $OUTPUT == "1" ] ; then
  1084. sleep 5
  1085. fi
  1086. # Restore build env files to previous state
  1087. sed -i -- "s/^#define FLASHEND .*$/#define FLASHEND 0x3FFFF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1088. sed -i -- "s/^prusa_einsy_rambo.upload.maximum_size.*/prusa_einsy_rambo.upload.maximum_size=253952/g" $BUILD_ENV_PATH/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION/boards.txt
  1089. sed -i -- "s/^#define RAMEND.*/#define RAMEND 0x21FF/g" $BUILD_ENV_PATH/hardware/tools/avr/avr/include/avr/iom2560.h
  1090. done
  1091. # Switch to hex path and list build files
  1092. cd $SCRIPT_PATH
  1093. echo "$(tput setaf 2) "
  1094. echo " "
  1095. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  1096. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  1097. #### End building
  1098. #### MK404 Simulator
  1099. # Check/compile MK404 sim
  1100. if [ ! -z "$mk404_flag" ]; then
  1101. ./MK404-build.sh -c1 || exit 61
  1102. # For Prusa MK2, MK2.5/S
  1103. if [ "$MOTHERBOARD" == "BOARD_RAMBO_MINI_1_3" ]; then
  1104. MK404_PRINTER="${MK404_PRINTER}_mR13"
  1105. else
  1106. if [[ "$mk404_flag" == "2" || "$mk404_flag" == "MMU2" || "$mk404_flag" == "MMU2S" ]]; then # Check if MMU2 is selected only for MK3/S
  1107. MK404_PRINTER="${MK404_PRINTER}MMU2"
  1108. fi
  1109. fi
  1110. # Run MK404 with 'debugcore' and/or 'bootloader-file'
  1111. if [[ ! -z $MK404_DEBUG && "$MK404_DEBUG" == "atmega404" || ! -z $BOARD_MEM && "$BOARD_MEM" == "0xFFFF" ]]; then
  1112. MK404_options="--debugcore"
  1113. fi
  1114. if [[ ! -z $MK404_DEBUG && "$MK404_DEBUG" == "atmega404_no_bootloader" || ! -z $BOARD_FLASH && "$BOARD_FLASH" != "0x3FFFF" ]]; then
  1115. MK404_options='--debugcore --bootloader-file ""'
  1116. fi
  1117. # Run MK404 with grafics
  1118. if [ ! -z "$graphics_flag" ]; then
  1119. if [ ! -z "$MK404_options" ]; then
  1120. MK404_options="${MK404_options} --colour-extrusion --extrusion Quad_HR -g "
  1121. else
  1122. MK404_options="--colour-extrusion --extrusion Quad_HR -g "
  1123. fi
  1124. if [[ "$graphics_flag" == "1" || "$graphics_flag" == "lite" ]]; then
  1125. MK404_options="${MK404_options}lite"
  1126. elif [[ "$graphics_flag" == "2" || "$graphics_flag" == "fancy" ]]; then
  1127. MK404_options="${MK404_options}fancy"
  1128. else
  1129. echo "$(tput setaf 1)Unsupported MK404 graphics option $graphics_flag$(tput sgr 0)"
  1130. fi
  1131. fi
  1132. # Output some useful data
  1133. echo "Printer: $MK404_PRINTER"
  1134. echo "Options: $MK404_options"
  1135. echo ""
  1136. read -t 5 -p "Press $(tput setaf 2)Enter$(tput sgr 0) to start MK404"
  1137. echo ""
  1138. # Change to MK404 build folder
  1139. cd ../MK404/master/build
  1140. #Decide which hex file to use EN_ONLY or Multi language
  1141. if [ "$LANGUAGES" == "ALL" ]; then
  1142. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  1143. else
  1144. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex
  1145. fi
  1146. # Start MK404
  1147. # default with serial output and terminal to manipulate it via terminal
  1148. echo ""
  1149. echo "./MK404 Prusa_$MK404_PRINTER -s --terminal $MK404_options -f $MK404_firmware_file"
  1150. sleep 5
  1151. ./MK404 Prusa_$MK404_PRINTER -s --terminal $MK404_options -f $MK404_firmware_file || exit 62
  1152. fi
  1153. #### End of MK404 Simulator